/* $Workfile: Dsp55Demo1Io.h $   $Revision: 1 $    $Modtime: 2/01/12 4:59p $  */
#ifndef DSP55_DEMO1_IO_H
#define DSP55_DEMO1_IO_H
/*--------------------------------------------------------------------------*\

  Copyright (c) Odin TeleSystems Inc., 2012, All Rights Reserved.

  SAA-1007-1 OTX DSP C54x Software Development Kit (SDK)

  IOCLT Codes and Structs for communication between the DSP code and the
  DSPDMO1 user application

\*--------------------------------------------------------------------------*/


/*******************************************************************************
  @devnote
   DSP IOCTL codes.
*******************************************************************************/

#define DEMO1_IOCTL_SET_BLINK_FREQ              0x0100
#define DEMO1_IOCTL_GET_BLINK_FREQ              0x0101
#define DEMO1_IOCTL_GET_DEBUG_DATA              0x0102
#define DEMO1_IOCTL_GET_HPI_EVENT_BUF_DIAG      0x0103
#define DEMO1_IOCTL_SET_CO_DEBUG_NOTIFICATIONS  0x0104
#define DEMO1_IOCTL_GET_CHIP_INFO               0x0105

/*******************************************************************************
  @devnote
   DSP Notify Event codes.
*******************************************************************************/

#define DEMO1_NOTIFY_DEBUG_DATA       0x0200

/*******************************************************************************
  @devnote
   Structs for passing data over the DSP IOCTL interface
*******************************************************************************/


// Fix packing for IO Control Structs
//#pragma pack(2)

// Structs used in calls to OtxDspIoControl()
typedef struct Demo1IoInSetBlinkFreqS
{
  unsigned short        nBlinkCountFactor;
  unsigned short        nDummyData;
} Demo1IoInSetBlinkFreqS;

typedef struct Demo1IoInSetCoDebugNotificationsS
{
  unsigned short        coDebugDataNotifications;
} Demo1IoInSetCoDebugNotificationsS;

// Structs used for Notify Events
typedef struct Demo1NotifyGetDebugDataS
{
  unsigned short        nData0;
  unsigned short        nData1;
  unsigned short        nData2;

  unsigned short        sqBuf[300];
} Demo1NotifyGetDebugDataS;

typedef struct Demo1IoOutGetChipInfoS
{
  unsigned short        nResult;
  unsigned short        nRevId;
} Demo1IoOutGetChipInfoS;

typedef struct Demo1IoOutGetBlinkFreqS
{
  unsigned short        nResult;
  // long is complex to pack properly in a shared DSP and host struct. Therefore we only
  // use unsigned short in this demo example.
  unsigned short        nBlinkCountMaxLow;
  unsigned short        nBlinkCountMaxHigh;
  unsigned short        nBlinkCountLow;
  unsigned short        nBlinkCountHigh;
} Demo1IoOutGetBlinkFreqS;

typedef struct Demo1IoOutGetHpiEventBufDiagS
{
  unsigned short nResult;

  unsigned short cwFreeBuffer;    // Current number of free words in the HPI Event Buffer
  unsigned short cwMinFreeBuffer; // Minimum number of free words in the HPI Event Buffer since the application started
  unsigned short coLostEvents;    // Number of lost event packets (due to a full buffer) since the application started
} Demo1IoOutGetHpiEventBufDiagS;



//#pragma pack()


#endif  // DSP55_DEMO1_IO_H
